// Vertex Shader  file "particleShader.vert"

#version 330

//Shader for particle systems

uniform mat4 mvpMatrix;
uniform vec3 cameraPos;
uniform float shininess; //(=size of particle)

in  vec3 in_position;
in  vec4 in_color;

out vec4 color;

void main(void)
{

	color = in_color;

	float dist = length(cameraPos-in_position);

	gl_PointSize = shininess * sqrt(1/dist);


	if(gl_PointSize < 4.0)
		color = smoothstep(0.0, 4.0, gl_PointSize) * color;

	gl_Position = mvpMatrix * vec4(in_position,1);
}
